const dbConnection = require("../db/connection");

// const readXlsxFile = require("read-excel-file/node");

const path = require("path");

const fs = require("fs");

global.__basedir = __dirname;

medidasController = {};

let medidasMatrix = [];
let msgLog = [];
let counter = 0;

// * Carga la página del controlador.
medidasController.loadpage = (req, res) => {
	res.send("API medidas");
};

// * Descargar el documento a llenar.
medidasController.downloadfile = (req, res) => {
	const file = "assets/docs/medidas.xlsx";
	fs.access(file, fs.constants.F_OK, (err) => {
		if (err) {
			console.error("El archivo 'Medidas' no existe.");
			msgLog.push("El archivo 'Medidas' no existe.");
			res.status(404).json(msgLog);
			msgLog.length = 0;
		} else if (!err) {
			res.status(200).download(file);
			console.log("Archivo Medidas descargado");
		}
	});
};

// * Traer datos de la base de datos.
medidasController.medidas_list = (req, res) => {
	const query = "SELECT * FROM medidas";
	dbConnection.connectionDB.query(query, (error, response, results) => {
		if (error) {
			console.log(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

// * Guardar un archivo xlsx.
medidasController.savefile = (req, res) => {
	console.log("req.params :>> ", req.params.idEmpresas);

	let idEmpresa = req.params.idEmpresas;
	// ! Al recibir algo vacío.
	if (!req.file) {
		console.log("Debes subir un documento.");
		msgLog.push("Debes subir un documento.");
		res.json(msgLog);
		msgLog.length = 0;
	}

	let file_path = req.file.path;

	// ! Split de '\' para Windows.
	let file_split = file_path.split("\\");
	let file_name = file_split[2];
	let extension_split = file_name.split(".");
	let file_ext = extension_split[1];

	// * Valida la extensión del documento.
	if (file_ext != "xlsx") {
		// ! Borrar el documento subido.
		fs.unlink(file_path, (error) => {
			console.log(
				"El tipo de documento no es válido. Debes seleccionar un archivo .xlsx o descargar los proporcionados por el sistema.",
			);
			msgLog.push(
				"El tipo de documento no es válido. Debes seleccionar un archivo .xlsx o descargar los proporcionados por el sistema.",
			);
			res.json(msgLog);
			msgLog.length = 0;
		});
	} else {
		readXlsxFile("../uploads/" + req.file.filename).then(
			(excelMatrix) => {
				// * excelMatrix es una matriz en donde cada 'fila' es un arreglo.
				console.log(excelMatrix);

				// * Valida que el documento ingresado sea el correcto.
				if (excelMatrix[0].length !== 2) {
					console.log("El documento no es válido para 'Medidas'.");
					msgLog.push("El documento no es válido para 'Medidas'.");
					// console.log(msgLog);
					res.json(msgLog);
					msgLog.length = 0;
				} else {
					// * Se remueve el primer arreglo o fila del archivo ingresado representado como 'excelMatrix'.
					excelMatrix.shift();

					// * Llenado de la segunda matriz con el idEmpresa.
					medidasMatrix = excelMatrix.map((arr) => [
						...arr,
						idEmpresa,
					]);
					console.log("medidasMatrix :>> ", medidasMatrix);

					// ! Abre la conexión a MySQL.
					// dbConnection.connectionDB.connect((error) => {
					// 	if (error) {
					// 		console.log("CONNECTION ERROR :>> ", error);
					// 		console.log(
					// 			"CONNECTION CLOSED BY ERROR AT CONNECTION.",
					// 		);
					// 		dbConnection.connectionDB.end();
					// 	}
					// });

					// ! Comienzo de transacción.
					dbConnection.connectionDB.beginTransaction((err) => {
						if (err) {
							console.log("TRANSACTION ERROR :>> ", err);
						} else {
							// * Valida si no hay registros en el archivo.
							if (!medidasMatrix.length) {
								dbConnection.connectionDB.rollback(() => {
									console.log(
										"No hay registros en el archivo.",
									);
									msgLog.push(
										"No hay registros en el archivo.",
									);
									res.json(msgLog);
								});
							}

							// * Valida si la longitud de la matriz ingresada es mayor a 0.
							if (medidasMatrix.length > 0) {
								const SP_InsertMedidas =
									"CALL SP_InsertMedidas (?)";
								// medidasMatrix.forEach(
								// 	(medidasArray, index) =>
								// for (let medidasArray in medidasMatrix)
								// for
								medidasMatrix.forEach((medidasArray, index) => {
									let regExp = /[_,_|_%_|_#_|___|_'_|_:_|_;_]+/gimu;
									// let regExp = /[_DELETE_|_delete_|_DROP_|_drop_|_,_|_%_|_#_|___|_'_|_:_|_;_]+/gimu;

									// TODO: validar la expresión regular
									// if (
									// 	regExp.test(medidasArray[index]) ==
									// 	false
									// ) {
									// 	console.log(
									// 		"Hay registros con caracteres no válidos para el documento.",
									// 	);
									// 	msgLog.push(
									// 		"Hay registros con caracteres no válidos para el documento.",
									// 	);
									// 	counter++;
									// 	if (counter == medidasMatrix.length) {
									// 		console.log(msgLog);
									// 		res.json(msgLog);
									// 		msgLog.length = 0;
									// 	}
									// } else
									if (medidasArray.includes(null)) {
										console.log(
											`Fila ${index + 2
											}: Completar registros vacíos.`,
										);
										msgLog.push(
											`Fila ${index + 2
											}: Completar registros vacíos.`,
										);
										counter++;
										if (counter == medidasMatrix.length) {
											console.log(msgLog);
											res.json(msgLog);
											msgLog.length = 0;
										}
									} else if (!medidasArray.includes(null)) {
										dbConnection.connectionDB.query(
											SP_InsertMedidas,
											[medidasArray],
											(error, response) => {
												if (msgLog.length > 0) {
													dbConnection.connectionDB.rollback(
														() => {
															console.log(
																"ROLLBACK EMPTY FIELDS :>> ",
															);
															console.log(msgLog);
															res.json(msgLog);
															msgLog.length = 0;
														},
													);
												} else {
													if (error) {
														dbConnection.connectionDB.rollback(
															() => {
																console.log(
																	"QUERY > ROLLBACK ERROR SP_InsertMedidas :>> ",
																	error,
																);
																if (
																	error.code ==
																	"ER_DUP_ENTRY"
																) {
																	console.log(
																		"Base de datos: Registros duplicados.",
																	);
																	res.json({
																		msg:
																			"Base de datos: Registros duplicados.",
																	});
																}
															},
														);
													} else if (response) {
														console.log(
															"QUERY RESPONSE :>> ",
															response,
														);

														dbConnection.connectionDB.commit(
															(err) => {
																if (err) {
																	dbConnection.connectionDB.rollback(
																		() => {
																			console.log(
																				"COMMIT ERROR ROLLBACK SP_InsertMedidas :>>",
																				err,
																			);
																		},
																	);
																} else {
																	// console.log(
																	// 	"Archivo cargado / importado correctamente.",
																	// );
																	// msgLog.push(
																	// 	"Archivo cargado / importado correctamente.",
																	// );
																	counter++;
																	if (
																		counter ==
																		medidasMatrix.length
																	) {
																		if (
																			msgLog.length ==
																			0
																		) {
																			msgLog.push(
																				"Archivo cargado / importado correctamente.",
																			);
																		}
																		console.log(
																			msgLog,
																		);
																		res.json(
																			msgLog,
																		);
																		msgLog.length = 0;
																	}
																}
															},
														);
													}
												}
											},
										);
									}

									// TODO: validar las columnas del arreglo
									// if (medidasArray.length !== 2) {
									// 	console.log(
									// 		"El documento no es válido para 'Medidas'.",
									// 	);
									// 	msgLog.push(
									// 		"El documento no es válido para 'Medidas'.",
									// 	);
									// 	counter++;
									// 	if (counter == medidasMatrix.length) {
									// 		console.log(msgLog);
									// 		res.json(msgLog);
									// 		msgLog.length = 0;
									// 	}
									// } else {
									// }
								});
							}
						}
					});
				}
			},
		);
	}
};

module.exports.medidasController = medidasController;
