const dbConnection = require("../db/connection");

// const readXlsxFile = require("read-excel-file/node");

const fs = require("fs");

global.__basedir = __dirname;

nomenclaturaController = {};

arrayLog = [];
let nomenclaturaMatrix = [];
let msgLog = [];
let counter = 0;

// * Carga la página del controlador.
nomenclaturaController.loadpage = (req, res) => {
	res.send("API nomenclaturas");
};

// * Descargar el documento a llenar.
nomenclaturaController.downloadfile = (req, res) => {
	const file = "assets/docs/nomenclatura.xlsx";
	fs.access(file, fs.constants.F_OK, (err) => {
		if (err) {
			console.error("El archivo 'Nomenclatura' no existe.");
			msgLog.push("El archivo 'Nomenclatura' no existe.");
			res.status(404).json(msgLog);
			msgLog.length = 0;
		} else if (!err) {
			res.status(200).download(file);
			console.log("Archivo nomenclatura descargado");
		}
	});
};

// * Traer datos de la base de datos.
nomenclaturaController.nomenclatura_list = (req, res) => {
	const query = "SELECT * FROM nomenclatura";
	dbConnection.connectionDB.query(query, (error, response, results) => {
		if (error) {
			console.log(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};



nomenclaturaController.savefile = (req, res) => {
	console.log("req.params.idEmpresas :>> ", req.params.idEmpresas);
	let idEmpresa = req.params.idEmpresas;
	// ! Al recibir algo vacío.
	if (!req.file) {
		msgLog.length = 0;
		console.log("Debes subir un documento.");
		msgLog.push("Debes subir un documento.");
		res.status(200).send(msgLog);
		msgLog.length = 0;
	} else {
		let file_path = req.file.path;
		// ! Split de '\' para Windows.
		let file_split = file_path.split("\\");
		let file_name = file_split[2];
		let extension_split = file_name.split(".");
		let file_ext = extension_split[1];

		// * Valida la extensión del documento.
		if (file_ext != "xlsx") {
			// ! Borrar el documento subido.
			fs.unlink(file_path, (error) => {
				msgLog.length = 0;
				console.log(
					"El tipo de documento no es válido. Debes seleccionar un archivo .xlsx o descargar los proporcionados por el sistema.",
				);
				msgLog.push(
					"El tipo de documento no es válido. Debes seleccionar un archivo .xlsx o descargar los proporcionados por el sistema.",
				);
				res.status(200).json(msgLog);
				msgLog.length = 0;
			});
		} else {
			readXlsxFile("../uploads/" + req.file.filename).then(
				(excelMatrix) => {
					// * excelMatrix es una matriz en donde cada 'fila' es un arreglo.
					console.table(excelMatrix);

					// * Valida que el documento ingresado sea el correcto.
					if (excelMatrix[0].length !== 6) {
						msgLog.length = 0;
						console.log(
							"El documento no es válido para 'Nomenclatura'.",
						);
						msgLog.push(
							"El documento no es válido para 'Nomenclatura'.",
						);
						// console.log(msgLog);
						res.json(msgLog);
						msgLog.length = 0;
					} else {
						// * Se remueve el primer arreglo o fila del archivo ingresado representado como 'excelMatrix'.
						excelMatrix.shift();

						// * Llenado de la segunda matriz con el idEmpresa.
						nomenclaturaMatrix = excelMatrix.map((arr) => [
							...arr,
							idEmpresa,
						]);
						console.log("nomenclaturaMatrix :>> ", nomenclaturaMatrix);

						// ! Comienzo de transacción.
						dbConnection.connectionDB.beginTransaction((err) => {
							if (err) {
								console.log("TRANSACTION ERROR :>> ", err);
							} else {
								// * Valida si no hay registros en el archivo.
								if (!nomenclaturaMatrix.length) {
									dbConnection.connectionDB.rollback(() => {
										msgLog.length = 0;
										console.log(
											"No hay registros en el archivo.",
										);
										msgLog.push(
											"No hay registros en el archivo.",
										);
										res.json(msgLog);
									});
								}

								// * Valida si la longitud de la matriz ingresada es mayor a 0.
								if (nomenclaturaMatrix.length > 0) {
									const SP_Nomenclatura =
										"CALL SP_Nomenclatura (?)";
									// nomenclaturaMatrix.forEach(
									// 	(nomenclaturaArray, index) =>
									// for (let nomenclaturaArray in nomenclaturaMatrix)
									// for
									nomenclaturaMatrix.forEach(
										(nomenclaturaArray, index) => {
											let regExp = /[_,_|_%_|_#_|___|_'_|_:_|_;_]+/gimu;
											// let regExp = /[_DELETE_|_delete_|_DROP_|_drop_|_,_|_%_|_#_|___|_'_|_:_|_;_]+/gimu;

											// TODO: validar la expresión regular
											// if (
											// 	regExp.test(
											// 		nomenclaturaArray[index],
											// 	) == false
											// ) {
											// 	console.log(
											// 		"Hay registros con caracteres no válidos para el documento.",
											// 	);
											// 	msgLog.push(
											// 		"Hay registros con caracteres no válidos para el documento.",
											// 	);
											// 	counter++;
											// 	if (
											// 		counter ==
											// 		nomenclaturaMatrix.length
											// 	) {
											// 		console.log(msgLog);
											// 		res.json(msgLog);
											// 		msgLog.length = 0;
											// 	}
											// } else
											if (nomenclaturaArray.includes(null)) {
												msgLog.length = 0;
												console.log(
													`Fila ${
														index + 2
													}: Completar registros vacíos.`,
												);
												msgLog.push(
													`Fila ${
														index + 2
													}: Completar registros vacíos.`,
												);
												counter++;
												if (
													counter ==
													nomenclaturaMatrix.length
												) {
													console.log(msgLog);
													res.json(msgLog);
													msgLog.length = 0;
												}
											} else if (
												!nomenclaturaArray.includes(null)
											) {
												dbConnection.connectionDB.query(
													SP_Nomenclatura,
													[nomenclaturaArray],
													(error, response) => {
														if (msgLog.length > 0) {
															dbConnection.connectionDB.rollback(
																() => {
																	msgLog.length = 0;
																	console.log(
																		"ROLLBACK EMPTY FIELDS :>> ",
																	);
																	console.log(
																		msgLog,
																	);
																	res.json(
																		msgLog,
																	);
																	msgLog.length = 0;
																},
															);
														} else {
															if (error) {
																dbConnection.connectionDB.rollback(
																	() => {
																		console.log(
																			"QUERY > ROLLBACK ERROR SP_Nomenclatura :>> ",
																			error,
																		);
																		if (
																			error.code ==
																			"ER_DUP_ENTRY"
																		) {
																			console.log(
																				"Base de datos: Registros duplicados.",
																			);
																			res.json(
																				{
																					msg:
																						"Base de datos: Registros duplicados.",
																				},
																			);
																		}
																	},
																);
															} else if (response) {
																console.log(
																	"QUERY RESPONSE :>> ",
																	response,
																);

																dbConnection.connectionDB.commit(
																	(err) => {
																		if (err) {
																			dbConnection.connectionDB.rollback(
																				() => {
																					console.log(
																						"COMMIT ERROR ROLLBACK SP_Nomenclatura :>>",
																						err,
																					);
																				},
																			);
																		} else {
																			// console.log(
																			// 	"Archivo cargado / importado correctamente.",
																			// );
																			// msgLog.push(
																			// 	"Archivo cargado / importado correctamente.",
																			// );
																			counter++;
																			if (counter == nomenclaturaMatrix.length) {
																				if (msgLog.length == 0) {
																					msgLog.length = 0;
																					msgLog.push(
																						"Archivo cargado / importado correctamente.",
																					);
																				}
																				console.log(
																					msgLog,
																				);
																				res.json(
																					msgLog,
																				);
																				msgLog.length = 0;
																			}
																		}
																	},
																);
															}
														}
													},
												);
											}

											// TODO: validar las columnas del arreglo
											// if (nomenclaturaArray.length !== 2) {
											// 	console.log(
											// 		"El documento no es válido para 'nomenclatura'.",
											// 	);
											// 	msgLog.push(
											// 		"El documento no es válido para 'nomenclatura'.",
											// 	);
											// 	counter++;
											// 	if (counter == nomenclaturaMatrix.length) {
											// 		console.log(msgLog);
											// 		res.json(msgLog);
											// 		msgLog.length = 0;
											// 	}
											// } else { }
										},
									);
								}
							}
						});
					}
				},
			);
		}
	}
};
module.exports.nomenclaturaController = nomenclaturaController;
