const dbConnection = require("../db/connection");

// const readXlsxFile = require("read-excel-file/node");

const fs = require("fs");

const XLSX = require("xlsx");

const globalFun = require("./globalfuntions.controller");

const { logger_data, logger_msg } = require('../config/utils');

global.__basedir = __dirname;

productosController = {};

let productosMatrix = [];
let msgLog = [];
let counter = 0;

// * Carga la página del controlador.
productosController.loadpage = (req, res) => {
	res.send("API productos");
};

// * Descargar el documento a llenar.
productosController.downloadfile = (req, res) => {
	const file = "assets/docs/productos.xlsx";
	fs.access(file, fs.constants.F_OK, (err) => {
		if (err) {
			console.error("El archivo 'Productos' no existe.");
			msgLog.push("El archivo 'Productos' no existe.");
			res.status(404).json(msgLog);
			msgLog.length = 0;
		} else if (!err) {
			res.status(200).download(file);
			console.log("Archivo Productos descargado");
		}
	});
};

productosController.productos_carga_imgen = (req, res) => {
	const producto = {
		idEmpresas: Number(req.params.idEmpresas),
		id: Number(req.params.idProducto)
	};
	const productoImagenNombre = req.file.filename;

	if (!producto) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		if (!producto.idEmpresas || !producto.id) {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
			const queryProductoImagen = "UPDATE productos SET image=? WHERE id=? AND idEmpresas=?;"

			dbConnection.connectionDB.beginTransaction((err) => {
				if (err) {
					console.error("TRANSACTION ERROR :>> ", err);
				} else {
					dbConnection.connectionDB.query(queryProductoImagen, [productoImagenNombre, producto.id, producto.idEmpresas], (error, response, result) => {
						if (error) {
							if (error.code == 'ER_DUP_ENTRY') {
								dbConnection.connectionDB.rollback(() => {
									console.log("QUERY > ROLLBACK ERROR INSERT productos :>> ", error);
									const status = globalFunctions.statusMsg(6);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							} else {
								dbConnection.connectionDB.rollback(() => {
									console.log("QUERY > ROLLBACK ERROR INSERT productos :>> ", error);
									const status = globalFunctions.statusMsg(0);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							}

						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(result);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK INSERT productos :>> ",
											err,
										);
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						}
					},
					);
				}
			});
		}
	}
}

// * Traer datos de la base de datos.
productosController.productos_list = (req, res) => {
	const query = "SELECT * FROM productos";
	dbConnection.connectionDB.query(query, (error, results) => {
		if (error) {
			globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
			throw error;
		} else if (results.length > 0) {
			globalFunctions.logger(logger_data(req), 'info', logger_msg.info);
			res.json(results);
		} else {
			/*
			const status = globalFunctions.statusMsg(4);
			globalFunctions.logger(logger_data(req), 'error', status.status_message_description);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
			*/
			res.send("Sin resultados");
		}
	});
};

productosController.productos_last_id = (req, res) => {
	const query = "SELECT id FROM productos ORDER BY id DESC LIMIT 1";
	dbConnection.connectionDB.query(query, (error, response, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
}

// * Recibe el id de producto
productosController.productos_detail = (req, res) => {
	const producto = req.body;
	const query = "SELECT * FROM productos WHERE id = ? AND idEmpresas = ? LIMIT 1";
	dbConnection.connectionDB.query(query, [producto.id, producto.idEmpresas], (error, response, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

productosController.productos_create_post = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const producto = req.body;
	const newProduct = [
		producto.sku,
		producto.upc,
		producto.descLarga,
		parseFloat(producto.precioCosto, 2),
		parseFloat(producto.margen, 2),
		parseFloat(producto.precioPublico, 2),
		producto.idTipoProductos.toString(),
		producto.idFabricaProducto.toString(),
		producto.idUtilizaSerie.toString(),
		producto.idMedidas.toString(),
		parseFloat(producto.equivalente, 2),
		producto.idMedidas2.toString(),
		producto.idMarcas.toString(),
		producto.idFamiliaNivel1.toString(),
		producto.idFamiliaNivel2.toString(),
		producto.idFamiliaNivel3.toString(),
		producto.idStatusProducto.toString(),
		producto.idAvailableSale.toString(),
		parseInt(producto.idEmpresas, 10),
		parseInt(producto.id, 10)
	];
	console.log(newProduct);
	const SP_Productos = "CALL SP_Productos (?)";
	const SP_productosFormulario = "CALL SP_productosFormulario (?, @mensaje);" +
		"SELECT @mensaje as mensaje;";

	if (!producto) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {

		if (!producto.idEmpresas) {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
			dbConnection.connectionDB.beginTransaction((err) => {
				if (err) {
					console.error("TRANSACTION ERROR :>> ", err);
				} else {
					dbConnection.connectionDB.query(
						SP_productosFormulario, [newProduct],
						(error, response, result) => {
							if (error) {
								if (error.code == 'ER_DUP_ENTRY') {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT producto :>> ", error);
										const status = globalFunctions.statusMsg(6);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT producto :>> ", error);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								}

							} else if (response) {
								console.log("QUERY RESULT :>> ");
								console.log(response[1][0]);
								if (response[1][0].mensaje === 'SUCCESS') {
									dbConnection.connectionDB.commit((err) => {
										if (err) {
											dbConnection.connectionDB.rollback(() => {
												console.log(
													"COMMIT ERROR ROLLBACK INSERT producto :>> ",
													err,
												);
											});
										} else {
											const status = globalFunctions.statusMsg(1);
											msgLog.length = 0;
											msgLog.push(status);
											res.json(msgLog);
											msgLog.length = 0;
										}
									});
								} else if(response[1][0].mensaje === 'EXISTS') {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT producto :>> ", error);
										const status = globalFunctions.statusMsg(2);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								}
							}
						},
					);
				}
			});
		}
	}
}

productosController.productos_update_post = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const producto = req.body;
	const newProduct = [
		producto.sku,
		producto.upc,
		producto.descLarga,
		parseFloat(producto.precioCosto, 2),
		parseFloat(producto.margen, 2),
		parseFloat(producto.precioPublico, 2),
		producto.idTipoProductos.toString(),
		producto.idFabricaProducto.toString(),
		producto.idUtilizaSerie.toString(),
		producto.idMedidas.toString(),
		parseFloat(producto.equivalente, 2),
		producto.idMedidas2.toString(),
		producto.idMarcas.toString(),
		producto.idFamiliaNivel1.toString(),
		producto.idFamiliaNivel2.toString(),
		producto.idFamiliaNivel3.toString(),
		producto.idStatusProducto.toString(),
		producto.idAvailableSale.toString(),
		parseInt(producto.idEmpresas, 10)
	];
	const SP_Productos = "CALL SP_Productos (?)";

	const query = "UPDATE productos SET sku = ?, upc = ?, descLarga = ?, precioCosto = ?, margen = ?, precioPublico = ?, idTipoProductos = ?, idFabricaProducto = ?, idUtilizaSerie = ?, idMedidas = ?, equivalente = ?, idMedidas2 = ?, idMarcas = ?, idFamiliaNivel1 = ?, idFamiliaNivel2 = ?, idFamiliaNivel3 = ?, idGrupos = ?, idAvailableSale = ?, idStatusProducto = ?, idNomenclatura = ?, idCentrosCosto = ?, updated_at = CURRENT_TIMESTAMP() WHERE id=? AND idEmpresas=?;";

	const PRODUCT = [
		producto.sku,
		producto.upc,
		producto.descLarga,
		producto.precioCosto,
		producto.margen,
		producto.precioPublico,
		producto.idTipoProductos,
		producto.idFabricaProducto,
		producto.idUtilizaSerie,
		producto.idMedidas,
		producto.equivalente,
		producto.idMedidas2,
		producto.idMarcas,
		producto.idFamiliaNivel1,
		producto.idFamiliaNivel2,
		producto.idFamiliaNivel3,
		producto.idGrupos,
		producto.idAvailableSale,
		producto.idStatusProducto,
		producto.idNomenclatura,
		producto.idCentrosCosto,
		producto.id,
		producto.idEmpresas,
	];

	if (!producto) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {

		if (!producto.idEmpresas) {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
			dbConnection.connectionDB.beginTransaction((err) => {
				if (err) {
					console.error("TRANSACTION ERROR :>> ", err);
				} else {
					dbConnection.connectionDB.query(
						SP_Productos, [newProduct],
						(error, response, result) => {
							if (error) {
								if (error.code == 'ER_DUP_ENTRY') {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT producto :>> ", error);
										const status = globalFunctions.statusMsg(6);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT producto :>> ", error);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								}

							} else if (response) {
								console.log("QUERY RESULT :>> ");
								console.log(result);
								dbConnection.connectionDB.commit((err) => {
									if (err) {
										dbConnection.connectionDB.rollback(() => {
											console.log(
												"COMMIT ERROR ROLLBACK INSERT producto :>> ",
												err,
											);
										});
									} else {
										const status = globalFunctions.statusMsg(1);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									}
								});
							}
						},
					);
				}
			});
		}
	}
}

productosController.productos_delete_post = (req, res) => {
	const producto = req.body;
	if (!producto) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(producto);
		const query = "DELETE FROM productos WHERE id = ? AND idEmpresas = ?";
		// /*
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [producto.id, producto.idEmpresas],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' usuarios :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
							console.log("QUERY RESULT :>> ");
							console.log(result);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK 'DELETE' productos :>> ",
											err,
										);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						} else {
							const status = globalFunctions.statusMsg(4);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						}
					},
				);
			}
		});
		// */
	}
}

// * Guardar un archivo xlsx.
productosController.savefile = (req, res) => {
	const dateNhour = globalFun.globalFunctions.dateFunction("dateNhour");
	console.log(dateNhour + " INICIO DE CARGA");
	console.log(dateNhour + " req.params :>> ", req.params.idEmpresas);
	let idEmpresa = req.params.idEmpresas;
	// ! Al recibir algo vacío.
	if (!req.file) {
		console.log(dateNhour + " Debes subir un documento");
		msgLog.push("Debes subir un documento");
		res.json(msgLog);
		msgLog.length = 0;
	}

	let file_path = req.file.path;

	// ! Split de '\' para Windows.
	let file_split = file_path.split("\\");
	// ? file_split[N] es para la ruta en donde se encuentra el archivo
	// ? EJ: C:\pbs\proyecto-hannah\backend\controller\uploads\uploadfile-1607650796533-productos.xlsx
	// ? file_split[6];
	let file_name = file_split[2];
	let extension_split = file_name.split(".");
	let file_ext = extension_split[1];

	// * Valida la extensión del documento.
	if (file_ext != "xlsx") {
		// ! Borrar el documento subido.
		fs.unlink(file_path, (error) => {
			console.log(
				dateNhour +
				" El tipo de documento no es válido. Debes seleccionar un archivo .xlsx o descargar los proporcionados por el sistema.",
			);
			msgLog.push(
				"El tipo de documento no es válido. Debes seleccionar un archivo .xlsx o descargar los proporcionados por el sistema.",
			);
			res.json(msgLog);
			msgLog.length = 0;
		});
	} else {
		readXlsxFile("../uploads/" + req.file.filename).then((excelMatrix) => {
			// * excelMatrix es una matriz en donde cada 'fila' es un arreglo.
			console.log(dateNhour + excelMatrix);

			// * Valida que el documento ingresado sea el correcto.
			if (excelMatrix[0].length !== 18) {
				console.log(
					dateNhour + " El documento no es válido para 'Productos'.",
				);
				msgLog.push("El documento no es válido para 'Productos'.");
				// console.log(msgLog);
				res.json(msgLog);
				msgLog.length = 0;
			} else {
				// * Se remueve el primer arreglo o fila del archivo ingresado representado como 'excelMatrix'.
				excelMatrix.shift();
				// console.log(dateNhour + excelMatrix);

				// * Llenado de la segunda matriz con el idEmpresa.
				productosMatrix = excelMatrix.map((arr) => [...arr, idEmpresa]);
				console.log(
					dateNhour + " productosMatrix ===>",
					productosMatrix,
				);

				// ! Abre la conexión a MySQL.
				// dbConnection.connectionDB.connect((error) => {
				// 	if (error) {
				// 		console.log("CONNECTION ERROR ===> ", error);
				// 		console.log(
				// 			"CONNECTION CLOSED BY ERROR AT CONNECTION.",
				// 		);
				// 		dbConnection.connectionDB.end();
				// 	}
				// });

				// ! Comienzo de transacción.
				dbConnection.connectionDB.beginTransaction((err) => {
					if (err) {
						console.log(
							dateNhour + " TRANSACTION ERROR ===> ",
							err,
						);
					} else {
						// * Valida si no hay registros en el archivo.
						if (!productosMatrix.length) {
							dbConnection.connectionDB.rollback(() => {
								console.log(
									dateNhour +
									" No hay registros en el archivo.",
								);
								msgLog.push("No hay registros en el archivo.");
								res.json(msgLog);
							});
						}

						// * Valida si la longitud de la matriz ingresada es mayor a 0.
						if (productosMatrix.length > 0) {
							const SP_Productos = "CALL SP_Productos (?)";
							const SP_productosXlsx = "CALL SP_productosXlsx (?);";

							productosMatrix.forEach((productosArray, index) => {
								const regExp = /[_DELETE_|_delete_|_DROP_|_drop_|_,_|_%_|_#_|___|_'_|_:_|_;_]+/gimu;
								// console.log(productosArray[index]);

								// TODO: validar la expresión regular

								// * Validación: Columna 'UPC' si viene vacia añadir 0
								if (productosArray[1] == null) {
									productosArray[1] = 0;
								}

								// * Validación: Columna 'Costo' si viene vacia añadir 0
								if (productosArray[3] == null) {
									productosArray[3] = 0;
								}

								// * Validación: Columna 'Utilidad' si viene vacia añadir 0
								if (productosArray[4] == null) {
									productosArray[4] = 0;
								}

								// * Validación: Columna 'Precio' si viene vacia añadir 0
								if (productosArray[5] == null) {
									productosArray[5] = 0;
								}

								// * Validación: Columna 'Medida' si viene en minusculas hacerlo mayusculas
								if (productosArray[9]) {
									productosArray[9].toUpperCase();
								}

								// * Validación: Columna 'Medida2' si viene en minusculas hacerlo mayusculas
								if (productosArray[11]) {
									productosArray[11].toUpperCase();
								}

								if (productosArray.includes(null)) {
									console.log(
										dateNhour +
										` Fila ${index + 2
										}: Completar registros vacíos.`,
									);
									msgLog.push(
										`Fila ${index + 2
										}: Completar registros vacíos.`,
									);

									// * Validación: Columna 'Equivalente' sea numérica
									if (!Number(productosArray[10])) {
										console.log(
											dateNhour + " Equivalente ===> ",
											productosArray[10],
										);
										console.log(
											dateNhour +
											` Fila ${index + 2
											}: El registro debe ser de tipo numérico en la columna 'Equivalente'.`,
										);
										msgLog.push(
											`Fila ${index + 2
											}: El registro debe ser de tipo numérico en la columna 'Equivalente'.`,
										);
										counter++;
										if (counter == productosMatrix.length) {
											console.log(dateNhour + msgLog);
											res.json(msgLog);
											msgLog.length = 0;
										}
									}

									counter++;
									if (counter == productosMatrix.length) {
										console.log(dateNhour + msgLog);
										res.json(msgLog);
										msgLog.length = 0;
									}
									console.log(
										dateNhour + " productosMatrixNew ===>",
										productosMatrix,
									);
								} else if (!productosArray.includes(null)) {
									dbConnection.connectionDB.query(
										SP_productosXlsx,
										[productosArray],
										(error, response) => {
											if (msgLog.length > 0) {
												dbConnection.connectionDB.rollback(
													() => {
														console.log(
															dateNhour +
															" ROLLBACK EMPTY FIELDS ===> ",
														);
														console.log(
															dateNhour + msgLog,
														);
														res.json(msgLog);
														msgLog.length = 0;
													},
												);
											} else {
												if (error) {
													dbConnection.connectionDB.rollback(
														() => {
															console.log(
																dateNhour +
																" QUERY > ROLLBACK ERROR SP_Productos ===> ",
																error,
															);
															if (
																error.code ==
																"ER_DUP_ENTRY"
															) {
																console.log(
																	dateNhour +
																	" Base de datos: Registros duplicados.",
																);
																res.json({
																	msg:
																		"Base de datos: Registros duplicados.",
																});
															}
														},
													);
												} else if (response) {
													console.log(
														dateNhour +
														" QUERY RESPONSE ===> ",
														response,
													);

													dbConnection.connectionDB.commit(
														(err) => {
															if (err) {
																dbConnection.connectionDB.rollback(
																	() => {
																		console.log(
																			dateNhour +
																			" COMMIT ERROR ROLLBACK SP_Productos ===>",
																			err,
																		);
																	},
																);
															} else {
																counter++;
																if (
																	counter ==
																	productosMatrix.length
																) {
																	if (
																		msgLog.length ==
																		0
																	) {
																		msgLog.push(
																			"Archivo cargado / importado correctamente.",
																		);
																	}
																	console.log(
																		dateNhour +
																		msgLog,
																	);
																	res.json(
																		msgLog,
																	);
																	msgLog.length = 0;
																}
															}
														},
													);
												}
											}
										},
									);
								}
							});
						}
					}
				});
			}
		});
	}
};

module.exports.productosController = productosController;
