const dbConnection = require("../db/connection");
require("./globalfuntions.controller");

rolesController = {};

let msgLog = [];

rolesController.roles_loadpage = (req, res) => {
	res.send("API roles");
};

rolesController.roles_list = (req, res) => {
	const query = "SELECT * FROM roles";
	dbConnection.connectionDB.query(query, (error, results) => {
		if (error) throw error;

		if (results.length > 0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

rolesController.roles_detail = (req, res) => {
	const roles = req.body;
	const query = "SELECT * FROM roles WHERE id = ? LIMIT 1";
	dbConnection.connectionDB.query(query, [roles.id], (error, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (results.length > 0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

rolesController.roles_create_post = (req, res) => {
	const roles = req.body;
	console.table(roles);
	const query =
		"INSERT INTO roles (descripcion, created_at) VALUES( ?, CURRENT_TIMESTAMP());";

	dbConnection.connectionDB.beginTransaction((err) => {
		if (err) {
			console.error("TRANSACTION ERROR :>> ", err);
		} else {
			dbConnection.connectionDB.query(
				query,
				[
					roles.descripcion,
				],
				(error, response, result) => {
					if (error) {
						dbConnection.connectionDB.rollback(() => {
							console.log("QUERY > ROLLBACK ERROR INSERT roles :>> ", error);
							const status = globalFunctions.statusMsg(0);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						});
					} else if (response) {
						dbConnection.connectionDB.commit((err) => {
							if (err) {
								dbConnection.connectionDB.rollback(() => {
									console.log(
										"COMMIT ERROR ROLLBACK INSERT roles :>> ",
										err,
									);
								});
							} else {
								const status = globalFunctions.statusMsg(1);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							}
						});
					}
				},
			);
		}
	});
};

rolesController.roles_update_post = (req, res) => {
	const roles = req.body;

	if (!roles) {
		const status = gF.globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(roles);
		const query = "UPDATE roles SET descripcion = ?, updated_at = CURRENT_TIMESTAMP() WHERE id = ?";

		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						roles.descripcion,
						roles.id
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR UPDATE roles :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(result);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK UPDATE roles :>> ",
											err,
										);
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						}
					},
				);
			}
		});
	}
};

rolesController.roles_delete_post = (req, res) => {
	const roles = req.body;
	if (!roles) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(roles);
		const query = "DELETE FROM roles WHERE id = ?;";
		// /*
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [roles.id],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' usuarios :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK 'DELETE' roles :>> ",
											err,
										);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						} else {
							const status = globalFunctions.statusMsg(4);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						}
					},
				);
			}
		});
		// */
	}
};
module.exports.rolesController = rolesController;
