const dbConnection = require("../db/connection");
const gF = require("./globalfuntions.controller");

usuariosController = {};

let msgLog = [];

// * Carga la página del controlador.
usuariosController.usuarios_loadpage = (req, res) => {
	res.send("API usuarios");
};

// * Despliega una lista con todos los usuarios
usuariosController.usuarios_list = (req, res) => {
	// const query = "SELECT * FROM usuarios";
	// const query = "SELECT id, userName, codigoUsuario, user, pwd, pwd_real, (SELECT descripcion FROM roles WHERE id = usuarios.idRoles) as idRoles, (SELECT descripcion FROM sucursales WHERE id = usuarios.idSucursales) as idSucursales, (SELECT nombreComercial FROM empresas WHERE id = usuarios.idEmpresas) as idEmpresas, (SELECT descripcion FROM statusEmpleado WHERE id = usuarios.idStatusEmpleado) as idStatusEmpleado FROM usuarios;";
	const query = "SELECT id, userName, codigoUsuario, user, pwd, pwd_real, (SELECT descripcion FROM roles WHERE id = usuarios.idRoles) as idRoles, (SELECT descripcion FROM sucursales WHERE id = usuarios.idSucursales) as idSucursales, (SELECT nombreComercial FROM empresas WHERE id = usuarios.idEmpresas) as idEmpresas, (SELECT descripcion FROM statusEmpleado WHERE id = usuarios.idStatusEmpleado) as idStatusEmpleado FROM usuarios WHERE (SELECT descripcion FROM statusEmpleado WHERE id = usuarios.idStatusEmpleado) != 'Eliminado';";
	dbConnection.connectionDB.query(query, (error, response, results) => {
		if (error) {
			console.log(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			// console.log(response);
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

// * Recibe el id de usuario
usuariosController.usuarios_detail = (req, res) => {
	const usuario = req.body;
	console.table(usuario);
	const query = "SELECT * FROM usuarios WHERE id = ? AND idEmpresas = ? LIMIT 1";
	dbConnection.connectionDB.query(query, [usuario.id, usuario.idEmpresas], (error, response, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

usuariosController.usuarios_last_id = (req, res) => {
	const query = "SELECT id FROM usuarios ORDER BY id DESC LIMIT 1";
	dbConnection.connectionDB.query(query, (error, response, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			if (response.length == 0) {
				res.json([{ id: 0 }]);
			} else {
				res.json(response);
			}
		} else {
			const status = globalFunctions.statusMsg(4);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
}

usuariosController.usuarios_create_post = (req, res) => {
	const usuario = req.body;

	if (!usuario) {
		const status = gF.globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {

		if (!usuario.userName ||
			!usuario.codigoUsuario ||
			!usuario.user ||
			!usuario.pwd ||
			!usuario.pwd ||
			!usuario.idRoles ||
			!usuario.idSucursales ||
			!usuario.idEmpresas ||
			!usuario.idStatusEmpleado) {
			const status = gF.globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
			const query =
				"CALL SP_Insert_Usuarios_DocumentosCorrelativos_v3(?,?,?,?,?,?,?,?);";

			dbConnection.connectionDB.beginTransaction((err) => {
				if (err) {
					console.error("TRANSACTION ERROR :>> ", err);
				} else {
					dbConnection.connectionDB.query(
						query,
						[
							usuario.userName,
							usuario.codigoUsuario,
							usuario.user,
							usuario.pwd,
							usuario.idRoles,
							usuario.idSucursales,
							usuario.idEmpresas,
							usuario.idStatusEmpleado,
						],
						(error, response, result) => {
							if (error) {
								if (error.code == 'ER_DUP_ENTRY') {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT usuarios :>> ", error);
										const status = globalFunctions.statusMsg(6);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT usuarios :>> ", error);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								}

							} else if (response) {
								console.log("QUERY RESULT :>> ");
								console.log(result);
								dbConnection.connectionDB.commit((err) => {
									if (err) {
										dbConnection.connectionDB.rollback(() => {
											console.log(
												"COMMIT ERROR ROLLBACK INSERT usuarios :>> ",
												err,
											);
										});
									} else {
										const status = globalFunctions.statusMsg(1);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									}
								});
							}
						},
					);
				}
			});
		}
	}
};

usuariosController.usuarios_update_post = (req, res) => {
	const usuario = req.body;

	if (!usuario) {
		const status = gF.globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(usuario);
		const query = "UPDATE usuarios SET userName = ?, codigoUsuario = ?, user = ?, pwd = MD5(?), pwd_real = ?, idRoles = ?, idSucursales = ?,  idStatusEmpleado = ?, updated_at = CURRENT_TIMESTAMP() WHERE id = ? AND idEmpresas = ?";

		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						usuario.userName,
						usuario.codigoUsuario,
						usuario.user,
						usuario.pwd,
						usuario.pwd,
						usuario.idRoles,
						usuario.idSucursales,
						usuario.idStatusEmpleado,
						usuario.id,
						usuario.idEmpresas
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR UPDATE usuarios :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(result);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK UPDATE usuarios :>> ",
											err,
										);
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						}
					},
				);
			}
		});
	}
}

usuariosController.usuarios_delete_post = (req, res) => {
	const usuario = req.body;

	if (!usuario) {
		const status = gF.globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(usuario);
		const query = "DELETE FROM usuarios WHERE id = ? AND idEmpresas = ?";
		const query_hide = "UPDATE usuarios SET idStatusEmpleado = 3  WHERE id = ? AND idEmpresas = ?";
		// /*
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query_hide, [usuario.id, usuario.idEmpresas],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' usuarios :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
							console.log("QUERY RESULT :>> ");
							console.log(result);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK 'DELETE' usuarios :>> ",
											err,
										);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						} else {
							const status = globalFunctions.statusMsg(4);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						}
					},
				);
			}
		});
		// */
	}
}

module.exports.usuariosController = usuariosController;
