// https://github.com/wiredmax/world-currencies
// https://www.currency-iso.org/dam/downloads/lists/list_one.xml
// https://github.com/mledoze/countries

module.exports = {
  EUR   : { major : 'euro'                    , symbol : '€'          , precision : 2 , minor : 'cent'              , inSymbol : 'c'         , name : 'Euros'                      },
  USD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : '¢'         , name : 'US Dollar'                  },
  GBP   : { major : 'pound'                   , symbol : '£'          , precision : 2 , minor : 'penny'             , inSymbol : 'p'         , name : 'British Pound'              },
  CAD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : '¢'         , name : 'Canadian Dollar'            },
  CHF   : { major : 'franc'                   , symbol : 'CHF'        , precision : 2 , minor : 'rappen'            , inSymbol : 'Rp.'       , name : 'Swiss Franc'                },
  AED   : { major : 'dirham'                  , symbol : '.د.ب'       , precision : 2 , minor : 'fils'              , inSymbol : 'فلس'       , name : 'Emirati Dirham'             },
  AFN   : { major : 'afghani'                 , symbol : '؋'          , precision : 2 , minor : 'Pul'               , inSymbol : ''          , name : 'Afghan Afghani'             },
  ALL   : { major : 'lek'                     , symbol : 'lek'        , precision : 2 , minor : 'Qindarkë'          , inSymbol : ''          , name : 'Albanian lek'               },
  AMD   : { major : 'dram'                    , symbol : ''           , precision : 2 , minor : 'luma'              , inSymbol : ''          , name : 'Armenian dram'              },
  ANG   : { major : 'guilder'                 , symbol : 'ƒ'          , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Dutch Guilder'              },
  AOA   : { major : 'Kwanza'                  , symbol : 'Kz'         , precision : 2 , minor : 'cêntimos'          , inSymbol : ''          , name : 'Angolan Kwanza'             },
  ARS   : { major : 'peso'                    , symbol : '$'          , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Argentine peso'             },
  AUD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : 'c'         , name : 'Australian Dollar'          },
  AWG   : { major : 'florin'                  , symbol : 'ƒ'          , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Arubin florin'              },
  AZN   : { major : 'manat'                   , symbol : 'ман'        , precision : 2 , minor : 'Qepik'             , inSymbol : 'qr'        , name : 'Azerbaijani manat'          },
  BAM   : { major : 'convertible marks'       , symbol : 'KM'         , precision : 2 , minor : 'fening'            , inSymbol : ''          , name : 'Bosnian Convertible Marka'  },
  BBD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Barbadian dollar'           },
  BDT   : { major : 'Taka'                    , symbol : 'Tk'         , precision : 2 , minor : 'Poisha'            , inSymbol : ''          , name : 'Bangladeshi Taka'           },
  BGN   : { major : 'lev'                     , symbol : 'лв'         , precision : 2 , minor : 'stotinki'          , inSymbol : 'стотинки'  , name : 'Bulgarian lev'              },
  BHD   : { major : 'dinar'                   , symbol : '.د.ب or BD' , precision : 3 , minor : 'fils'              , inSymbol : ''          , name : 'Bahraini Dinar'             },
  BIF   : { major : 'franc'                   , symbol : ''           , precision : 2 , minor : 'centime'           , inSymbol : ''          , name : 'Burundian Franc'            },
  BMD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : '¢'         , name : 'Bermudian dollar'           },
  BND   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Bruneian Dollar'            },
  BOB   : { major : 'boliviano'               , symbol : '$b'         , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Bolivian Boliviano'         },
  BRL   : { major : 'real'                    , symbol : 'R$'         , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Brazilian real'             },
  BSD   : { major : 'dollar'                  , symbol : 'B$'         , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Bahamian dollar'            },
  BTN   : { major : 'Ngultrum'                , symbol : 'Nu.'        , precision : 2 , minor : 'Chhertum'          , inSymbol : 'Ch.'       , name : 'Bhutanese Ngultrum'         },
  BWP   : { major : 'Pula'                    , symbol : 'P'          , precision : 2 , minor : 'Thebe'             , inSymbol : 't'         , name : 'Botswana Pula'              },
  BYN   : { major : 'ruble'                   , symbol : 'р'          , precision : 2 , minor : 'kapeyka'           , inSymbol : 'к'         , name : 'Belarusian ruble'           },
  BZD   : { major : 'dollar'                  , symbol : 'BZ$'        , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Belize dollar'              },
  CLP   : { major : 'peso'                    , symbol : '$'          , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Chilean Peso'               },
  CNY   : { major : 'yuan'                    , symbol : '¥'          , precision : 2 , minor : 'fēn'               , inSymbol : '分'        , name : 'Yuan or chinese renminbi'   },
  COP   : { major : 'peso'                    , symbol : '$'          , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Colombian peso'             },
  CRC   : { major : 'colón'                   , symbol : '₡'          , precision : 2 , minor : 'céntimo'           , inSymbol : '₡'         , name : 'Costa Rican colón'          },
  CUC   : { major : 'peso'                    , symbol : '$'          , precision : 2 , minor : 'centavo'           , inSymbol : '¢'         , name : 'Cuban convertible peso'     },
  CUP   : { major : 'peso'                    , symbol : '₱'          , precision : 2 , minor : 'centavo'           , inSymbol : '¢'         , name : 'Cuban peso'                 },
  CVE   : { major : 'escudo'                  , symbol : '$'          , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Cape Verdean Escudo'        },
  CZK   : { major : 'koruna'                  , symbol : 'Kč'         , precision : 2 , minor : 'haléř'             , inSymbol : 'h'         , name : 'Czech koruna'               },
  DJF   : { major : 'franc'                   , symbol : 'fdj'        , precision : 2 , minor : 'centime'           , inSymbol : ''          , name : 'Djiboutian Franc'           },
  DKK   : { major : 'kroner'                  , symbol : 'kr'         , precision : 2 , minor : 'kroner'            , inSymbol : 'øre'       , name : 'Danish krone'               },
  DOP   : { major : 'peso'                    , symbol : '$'          , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Dominican peso'             },
  DZD   : { major : 'dinar'                   , symbol : 'جد'         , precision : 2 , minor : 'Santeem'           , inSymbol : ''          , name : 'Algerian Dinar'             },
  EGP   : { major : 'pound'                   , symbol : '£ '         , precision : 2 , minor : 'piastre'           , inSymbol : 'Pt'        , name : 'Egyptian Pound'             },
  ERN   : { major : 'nafka'                   , symbol : 'ናቕፋ'        , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Eritrean nakfa'             },
  ETB   : { major : 'Birr'                    , symbol : 'Br'         , precision : 2 , minor : 'santim'            , inSymbol : ''          , name : 'Ethiopian Birr'             },
  FJD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : '¢'         , name : 'Fijian dollar'              },
  FKP   : { major : 'pound'                   , symbol : '£'          , precision : 2 , minor : 'penny'             , inSymbol : 'p'         , name : 'Falkland Island Pound'      },
  GEL   : { major : 'lari'                    , symbol : 'ლ'          , precision : 2 , minor : 'tetri'             , inSymbol : ''          , name : 'Georgian lari'              },
  GHS   : { major : 'Cedi'                    , symbol : 'GH¢'        , precision : 2 , minor : 'Pesewa'            , inSymbol : 'Gp'        , name : 'Ghanaian Cedi'              },
  GIP   : { major : 'pound'                   , symbol : '£'          , precision : 2 , minor : 'penny'             , inSymbol : 'p'         , name : 'Gibraltar pound'            },
  GMD   : { major : 'dalasi'                  , symbol : ''           , precision : 2 , minor : 'butut'             , inSymbol : ''          , name : 'Gambian dalasi'             },
  GNF   : { major : 'franc'                   , symbol : ''           , precision : 2 , minor : 'centime'           , inSymbol : ''          , name : 'Guinean Franc'              },
  GTQ   : { major : 'quetzales'               , symbol : 'Q'          , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Guatemalan Quetzal'         },
  GYD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Guyanese dollar'            },
  HKD   : { major : 'dollar'                  , symbol : 'HK$'        , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Hong Kong dollar'           },
  HNL   : { major : 'lempira'                 , symbol : 'L'          , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Honduran lempira'           },
  HRK   : { major : 'kuna'                    , symbol : 'kn'         , precision : 2 , minor : 'lipa'              , inSymbol : 'lp'        , name : 'Croatian kuna'              },
  HTG   : { major : 'gourde'                  , symbol : 'G'          , precision : 2 , minor : 'centime'           , inSymbol : ''          , name : 'Haitian gourde'             },
  HUF   : { major : 'forint'                  , symbol : 'Ft'         , precision : 2 , minor : 'fillér'            , inSymbol : ''          , name : 'Hungarian forint'           },
  IDR   : { major : 'Rupiah'                  , symbol : 'Rp'         , precision : 2 , minor : 'Sen'               , inSymbol : ''          , name : 'Indonesian Rupiah'          },
  ILS   : { major : 'Shekel'                  , symbol : '₪'          , precision : 2 , minor : 'Agorat'            , inSymbol : ''          , name : 'Israeli Shekel'             },
  INR   : { major : 'Rupee'                   , symbol : '₹'          , precision : 2 , minor : 'paisa'             , inSymbol : 'p'         , name : 'Indian Rupee'               },
  IQD   : { major : 'dinar'                   , symbol : 'ع.د'        , precision : 3 , minor : 'fils'              , inSymbol : ''          , name : 'Iraqi Dinar'                },
  IRR   : { major : 'rial'                    , symbol : ''           , precision : 2 , minor : 'dinar'             , inSymbol : ''          , name : 'Iranian Rial'               },
  ISK   : { major : 'krona'                   , symbol : 'kr'         , precision : 2 , minor : 'eyrir'             , inSymbol : ''          , name : 'Icelandic Krona'            },
  JMD   : { major : 'dollar'                  , symbol : 'J$'         , precision : 2 , minor : 'cent'              , inSymbol : 'c'         , name : 'Jamaican dollar'            },
  JOD   : { major : 'Dinar'                   , symbol : ''           , precision : 2 , minor : 'qirsh ou piastre'  , inSymbol : ''          , name : 'Jordanian Dinar'            },
  JPY   : { major : 'yen'                     , symbol : '¥'          , precision : 2 , minor : 'sen'               , inSymbol : ''          , name : 'Japanese yen'               },
  KES   : { major : 'Shilling'                , symbol : 'KSh'        , precision : 2 , minor : 'cent'              , inSymbol : 'c'         , name : 'Kenyan Shilling'            },
  KGS   : { major : 'som'                     , symbol : 'лв'         , precision : 2 , minor : 'tyiyn'             , inSymbol : ''          , name : 'Kyrgyzstani som'            },
  KHR   : { major : 'riel'                    , symbol : '៛'          , precision : 1 , minor : 'kak'               , inSymbol : ''          , name : 'Cambodian Riel'             },
  KMF   : { major : 'franc'                   , symbol : ''           , precision : 2 , minor : 'centime'           , inSymbol : ''          , name : 'Comoran Franc'              },
  KPW   : { major : 'won'                     , symbol : '₩'          , precision : 2 , minor : 'chon'              , inSymbol : ''          , name : 'North Korean won'           },
  KRW   : { major : 'won'                     , symbol : '₩'          , precision : 2 , minor : 'jeon'              , inSymbol : ''          , name : 'South Korean won'           },
  KWD   : { major : 'dinar'                   , symbol : 'ك'          , precision : 3 , minor : 'fils'              , inSymbol : ''          , name : 'Kuwaiti Dinar'              },
  KYD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Caymanian Dollar'           },
  KZT   : { major : 'tenge'                   , symbol : '₸'          , precision : 2 , minor : 'tïın'              , inSymbol : ''          , name : 'Kazakhstani tenge'          },
  LAK   : { major : 'Kip'                     , symbol : '₭'          , precision : 2 , minor : 'Att'               , inSymbol : ''          , name : 'Lao or Laotian Kip'         },
  LBP   : { major : 'pound'                   , symbol : 'ل.ل'        , precision : 2 , minor : 'piastre'           , inSymbol : ''          , name : 'Lebanese Pound'             },
  LKR   : { major : 'Rupee'                   , symbol : 'Rs'         , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Sri Lankan Rupee'           },
  LRD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : '¢'         , name : 'Liberian Dollar'            },
  LSL   : { major : 'loti (maloti)'           , symbol : 'L or M'     , precision : 2 , minor : 'sente (lisente)'   , inSymbol : ''          , name : 'Lesotho loti'               },
  LTL   : { major : 'litas'                   , symbol : 'Lt'         , precision : 2 , minor : 'centas'            , inSymbol : 'ct'        , name : 'Lithuanian litas'           },
  LYD   : { major : 'dinar'                   , symbol : ' د.ل'       , precision : 2 , minor : 'dirham'            , inSymbol : ''          , name : 'Libyan Dinar'               },
  MAD   : { major : 'dirham'                  , symbol : 'م.د.'       , precision : 2 , minor : 'santim'            , inSymbol : 'santimat'  , name : 'Moroccan Dirham'            },
  MDL   : { major : 'Leu'                     , symbol : 'L'          , precision : 2 , minor : 'Ban'               , inSymbol : ''          , name : 'Moldovan Leu'               },
  MGA   : { major : 'Ariary'                  , symbol : 'Ar'         , precision : 1 , minor : 'Iraimbilanja'      , inSymbol : ''          , name : 'Malagasy Ariary'            },
  MKD   : { major : 'denar'                   , symbol : 'ден'        , precision : 2 , minor : 'deni'              , inSymbol : ''          , name : 'Macedonian Denar'           },
  MMK   : { major : 'Kyat'                    , symbol : 'K'          , precision : 2 , minor : 'Pya'               , inSymbol : ''          , name : 'Burmese Kyat'               },
  MNT   : { major : 'Tughrik'                 , symbol : '₮'          , precision : 2 , minor : 'Möngö'             , inSymbol : ''          , name : 'Mongolian Tughrik'          },
  MOP   : { major : 'pataca'                  , symbol : 'MOP$'       , precision : 1 , minor : 'ho'                , inSymbol : '毫'        , name : 'Macau Pataca'               },
  MRO   : { major : 'Ouguiya'                 , symbol : 'UM'         , precision : 2 , minor : 'khoums'            , inSymbol : ''          , name : 'Mauritanian Ouguiya'        },
  MUR   : { major : 'rupee'                   , symbol : 'Rs'         , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Mauritian rupee'            },
  MVR   : { major : 'Rufiyaa'                 , symbol : 'rf'         , precision : 2 , minor : 'laari'             , inSymbol : ''          , name : 'Maldivian Rufiyaa'          },
  MWK   : { major : 'Kwacha'                  , symbol : 'MK'         , precision : 2 , minor : 'Tambala'           , inSymbol : ''          , name : 'Malawian Kwacha'            },
  MXN   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'centavo'           , inSymbol : '¢'         , name : 'Mexico Peso'                },
  MYR   : { major : 'Ringgit'                 , symbol : 'RM'         , precision : 2 , minor : 'Sen'               , inSymbol : 'Sen'       , name : 'Malaysian Ringgit'          },
  MZN   : { major : 'metical'                 , symbol : 'MT'         , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Mozambican Metical'         },
  NAD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : 'c'         , name : 'Namibian Dollar'            },
  NGN   : { major : 'Naira'                   , symbol : '₦'          , precision : 2 , minor : 'Kobo'              , inSymbol : ''          , name : 'Nigerian Naira'             },
  NIO   : { major : 'córdoba'                 , symbol : 'C$'         , precision : 2 , minor : 'centavo'           , inSymbol : ''          , name : 'Nicaraguan córdoba'         },
  NOK   : { major : 'Krone'                   , symbol : 'kr'         , precision : 2 , minor : 'øre'               , inSymbol : ''          , name : 'Norwegian krone'            },
  NPR   : { major : 'Rupee'                   , symbol : 'Rs'         , precision : 2 , minor : 'Paisa'             , inSymbol : ''          , name : 'Nepalese Rupee'             },
  NZD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : 'c'         , name : 'New Zealand Dollar'         },
  OMR   : { major : 'rial'                    , symbol : 'ع.ر.'       , precision : 3 , minor : 'baisa'             , inSymbol : 'bz'        , name : 'Omani Rial'                 },
  PAB   : { major : 'balboa'                  , symbol : 'B/'         , precision : 2 , minor : 'Centésimo'         , inSymbol : ''          , name : 'Balboa panamérn'            },
  PEN   : { major : 'nuevo sol'               , symbol : 'S/'         , precision : 2 , minor : 'céntimo'           , inSymbol : ''          , name : 'Peruvian nuevo sol'         },
  PGK   : { major : 'Kina'                    , symbol : 'K'          , precision : 2 , minor : 'Toea'              , inSymbol : ''          , name : 'Papua New Guinean Kina'     },
  PHP   : { major : 'Peso'                    , symbol : '₱'          , precision : 2 , minor : 'Sentimo'           , inSymbol : ''          , name : 'Philippine Peso'            },
  PKR   : { major : 'Rupee'                   , symbol : 'Rs'         , precision : 2 , minor : 'Paisa'             , inSymbol : ''          , name : 'Pakistani Rupee'            },
  PLN   : { major : 'złoty'                   , symbol : 'zł'         , precision : 2 , minor : 'Grosz'             , inSymbol : 'gr'        , name : 'Polish złoty'               },
  PYG   : { major : 'guarani'                 , symbol : '₲'          , precision : 2 , minor : 'céntimo'           , inSymbol : ''          , name : 'Paraguayan guarani'         },
  QAR   : { major : 'riyal'                   , symbol : 'ق.ر '       , precision : 2 , minor : 'dirham'            , inSymbol : ''          , name : 'Qatari Riyal'               },
  RON   : { major : 'leu'                     , symbol : 'lei'        , precision : 2 , minor : 'bani'              , inSymbol : ''          , name : 'Romanian leu'               },
  RSD   : { major : 'dinar'                   , symbol : 'РСД'        , precision : 2 , minor : 'para'              , inSymbol : ''          , name : 'Serbian Dinar'              },
  RUB   : { major : 'rouble'                  , symbol : '₽'          , precision : 2 , minor : 'kopeyka'           , inSymbol : 'к'         , name : 'Russian Rouble'             },
  RWF   : { major : 'franc'                   , symbol : 'FRw, RF, R₣', precision : 2 , minor : 'centime'           , inSymbol : ''          , name : 'Rwandan franc'              },
  SAR   : { major : 'riyal'                   , symbol : 'ر.س'        , precision : 2 , minor : 'Halala'            , inSymbol : ''          , name : 'Saudi Arabian Riyal'        },
  SBD   : { major : 'dollar'                  , symbol : 'SI$'        , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Solomon Islander Dollar'    },
  SCR   : { major : 'rupee'                   , symbol : 'Rs'         , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Seychellois Rupee'          },
  SDG   : { major : 'pound'                   , symbol : ''           , precision : 2 , minor : 'piastres'          , inSymbol : '.‏س.ج'      , name : 'Sudanese Pound'             },
  SEK   : { major : 'krona'                   , symbol : 'kr'         , precision : 2 , minor : 'ören'              , inSymbol : ''          , name : 'Swedish krona'              },
  SGD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : 'S¢'        , name : 'Singapore Dollar'           },
  SLL   : { major : 'Leone'                   , symbol : 'Le'         , precision : 2 , minor : 'cent'              , inSymbol : 'c'         , name : 'Sierra Leonean Leone'       },
  SOS   : { major : 'shilling'                , symbol : 'S'          , precision : 2 , minor : 'senti'             , inSymbol : ''          , name : 'Somali Shilling'            },
  SRD   : { major : 'dollar'                  , symbol : '$'          , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Surinamese dollar'          },
  SSP   : { major : 'pound'                   , symbol : '£'          , precision : 2 , minor : 'piaster'           , inSymbol : ''          , name : 'South Sudanese pound'       },
  SYP   : { major : 'pound'                   , symbol : '£'          , precision : 2 , minor : 'piastre'           , inSymbol : ''          , name : 'Syrian Pound'               },
  SZL   : { major : 'Lilangeni or emalangeni' , symbol : 'L or E'     , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Swazi Lilangeni'            },
  THB   : { major : 'baht'                    , symbol : '฿'          , precision : 2 , minor : 'satang'            , inSymbol : ''          , name : 'Thai Baht'                  },
  TJS   : { major : 'somoni'                  , symbol : ''           , precision : 2 , minor : 'diram'             , inSymbol : ''          , name : 'Tajikistani somoni'         },
  TMT   : { major : 'manat'                   , symbol : 'T'          , precision : 2 , minor : 'tenge'             , inSymbol : ''          , name : 'Turkmenistan manat'         },
  TND   : { major : 'dinar'                   , symbol : ''           , precision : 3 , minor : 'milim or millime'  , inSymbol : 'ت.د'       , name : 'Tunisian Dinar'             },
  TOP   : { major : 'hau'                     , symbol : 'T$'         , precision : 2 , minor : 'seniti'            , inSymbol : '¢'         , name : 'Tongan Pa\'anga'            },
  TRY   : { major : 'lira'                    , symbol : '₺'          , precision : 2 , minor : 'kuruş'             , inSymbol : 'Kr'        , name : 'Turkish Lira'               },
  TTD   : { major : 'dollar'                  , symbol : 'TT$'        , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Trinidadian dollar'         },
  TWD   : { major : 'dollar'                  , symbol : 'NT$'        , precision : 1 , minor : 'jiao'              , inSymbol : '角'        , name : 'Taiwan New Dollar'          },
  TZS   : { major : 'Shilling'                , symbol : 'Sh'         , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Tanzanian Shilling'         },
  UAH   : { major : 'Hryvnia'                 , symbol : '₴'          , precision : 2 , minor : 'Kopiyka'           , inSymbol : ''          , name : 'Ukrainian Hryvnia'          },
  UGX   : { major : 'Shilling'                , symbol : 'USh'        , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Ugandan Shilling'           },
  UYU   : { major : 'peso'                    , symbol : '$U'         , precision : 2 , minor : 'centésimo'         , inSymbol : '¢'         , name : 'Uruguayan peso'             },
  UZS   : { major : 'som'                     , symbol : 'лв'         , precision : 2 , minor : 'Tiyin'             , inSymbol : ''          , name : 'Uzbekistani som'            },
  VEF   : { major : 'bolívares fuertes'       , symbol : 'Bs'         , precision : 2 , minor : 'céntimo'           , inSymbol : '¢'         , name : 'Venezuelan bolivar'         },
  VND   : { major : 'dong'                    , symbol : '₫'          , precision : 2 , minor : 'xu'                , inSymbol : ''          , name : 'Vietnamese Dong'            },
  VUV   : { major : 'vatu'                    , symbol : 'VT'         , precision : 2 , minor : ''                  , inSymbol : ''          , name : 'Ni-Vanuatu Vatu'            },
  WST   : { major : 'tālā'                    , symbol : '$'          , precision : 2 , minor : 'sene'              , inSymbol : ''          , name : 'Samoan Tālā'                },
  XCD   : { major : 'dollar'                  , symbol : 'EC$'        , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'East Caribbean dollar'      },
  XOF   : { major : 'franc'                   , symbol : ''           , precision : 2 , minor : 'centime'           , inSymbol : ''          , name : 'CFA Franc'                  },
  XPF   : { major : 'franc'                   , symbol : ''           , precision : 2 , minor : 'centime'           , inSymbol : ''          , name : 'CFP Franc'                  },
  YER   : { major : 'rial'                    , symbol : ''           , precision : 2 , minor : 'fils'              , inSymbol : ''          , name : 'Yemeni Rial'                },
  ZAR   : { major : 'Rand'                    , symbol : 'R'          , precision : 2 , minor : 'cent'              , inSymbol : 'c'         , name : 'South African Rand'         },
  ZMW   : { major : 'Kwacha'                  , symbol : 'ZMK'        , precision : 2 , minor : 'ngwee'             , inSymbol : ''          , name : 'Zambian Kwacha'             },
  ZWD   : { major : 'dollar'                  , symbol : 'Z$'         , precision : 2 , minor : 'cent'              , inSymbol : ''          , name : 'Zimbabwean Dollar'          },
  /** CRYPTO-CURRENCIES */
  BTC   : { major : 'bitcoin'                 , symbol : '₿'          , precision : 8 , minor : 'satoshi'           , inSymbol : ''          , name : 'Bitcoin'                    },
  ETH   : { major : 'ether'                   , symbol : 'Ξ'          , precision : 9 , minor : 'wei'               , inSymbol : ''          , name : 'Ether'                      },
  XRP   : { major : 'ripple'                  , symbol : 'XRP'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Ripple'                     },
  BCH   : { major : 'bitcoin cash'            , symbol : 'BCH'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Bitcoin Cash'               },
  BSV   : { major : 'bitcoin SV'              , symbol : 'BSV'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Bitcoin SV'                 },
  LTC   : { major : 'litecoin'                , symbol : 'LTC'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Litecoin'                   },
  USDT  : { major : 'tether'                  , symbol : 'USDT'       , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Tether'                     },
  EOS   : { major : 'eos'                     , symbol : 'EOS'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'EOS'                        },
  BNB   : { major : 'binance coin'            , symbol : 'BNB'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Binance Coin'               },
  XTZ   : { major : 'tezos'                   , symbol : 'XTZ'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Tezos'                      },
  ADA   : { major : 'ADA'                     , symbol : 'ADA'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Cardano'                    },
  LINK  : { major : 'LINK'                    , symbol : 'LINK'       , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'ChainLink'                  },
  XMR   : { major : 'XMR'                     , symbol : 'XMR'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Monero'                     },
  XLM   : { major : 'XLM'                     , symbol : 'XLM'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Stellar'                    },
  TRX   : { major : 'TRX'                     , symbol : 'TRX'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Tron'                       },
  HT    : { major : 'HT'                      , symbol : 'HT'         , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Huobi Token'                },
  ETC   : { major : 'ETC'                     , symbol : 'ETC'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Ethereum Classic'           },
  NEO   : { major : 'NEO'                     , symbol : 'NEO'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Neo'                        },
  DASH  : { major : 'DASH'                    , symbol : 'DASH'       , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Dash'                       },
  LEO   : { major : 'LEO'                     , symbol : 'LEO'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'UNUS SED LEO'               },
  ATOM  : { major : 'ATOM'                    , symbol : 'ATOM'       , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Cosmos'                     },
  CRO   : { major : 'CRO'                     , symbol : 'CRO'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'crypto.com'                 },
  HEDG  : { major : 'HEDG'                    , symbol : 'HEDG'       , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Hedge Trade'                },
  MIOTA : { major : 'MIOTA'                   , symbol : 'MIOTA'      , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'IOTA'                       },
  MKR   : { major : 'MKR'                     , symbol : 'MKR'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'MAKER'                      },
  ZEC   : { major : 'ZEC'                     , symbol : 'ZEC'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Zcash'                      },
  ONT   : { major : 'ONT'                     , symbol : 'ONT'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Ontology'                   },
  XEM   : { major : 'XEM'                     , symbol : 'XEM'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'NEM'                        },
  USDC  : { major : 'USDC'                    , symbol : 'USDC'       , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'USD Coin'                   },
  VET   : { major : 'VET'                     , symbol : 'VET'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'VeChain'                    },
  BAT   : { major : 'BAT'                     , symbol : 'BAT'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'Basic Attention Token'      },
  OKB   : { major : 'OKB'                     , symbol : 'OKB'        , precision : 8 , minor : ''                  , inSymbol : ''          , name : 'OKB'                        },
};
