const { Router } = require("express");
const express = require("express");
const router = Router();

const path = require("path");
const bodyParser = require("body-parser");

const loginRoute = require("./login.route");
const empresasRoute = require('./empresas.route');
const empresaConfigRoute = require("./empresaconfig.route");

const nomenclaturasRoute = require("./nomenclaturas.route");
const centrosCostoRoute = require("./centroscosto.route");
const clientesRoute = require("./clientes.route");
const medidasRoute = require("./medidas.route");
const productosRoute = require("./productos.route");

const reportesRoute = require("./reportes.route");
const archivosExtensionesRoute = require("./archivos_extensiones.route");

const usuariosRoute = require("./usuarios.route");
const rolesRoute = require("./roles.route");
const sucursalesRoute = require("./sucursales.route");
const status_empleadoRoute = require("./status_empleado.route");

const tipoProductosRoute = require("./tipo_productos.route");
const marcasRoute = require("./marcas.route");
const familiaNivel1Route = require("./familia_nivel_1.route");
const familiaNivel2Route = require("./familia_nivel_2.route");
const familiaNivel3Route = require("./familia_nivel_3.route");
const gruposRoute = require("./grupos.route");
const pcaRoute = require("./productos_codigos_alternos.route");
const pcRoute = require("./productos_componentes.route");

const tokenAuth = require("../middleware/token.auth");

router.use(bodyParser.json());
router.use(
	bodyParser.urlencoded({
		extended: true,
	}),
);

router.use("/api/login", loginRoute);

router.use("/api/empresas", [tokenAuth.verifyToken], empresasRoute);
router.use("/api/empresaConfig", empresaConfigRoute);

router.use("/api/documentos/nomenclaturas", [tokenAuth.verifyToken], nomenclaturasRoute);
router.use("/api/documentos/centroscosto", [tokenAuth.verifyToken], centrosCostoRoute);
router.use("/api/documentos/clientes", [tokenAuth.verifyToken], clientesRoute);
router.use("/api/documentos/medidas", [tokenAuth.verifyToken], medidasRoute);
router.use("/api/documentos/productos", [tokenAuth.verifyToken], productosRoute);

router.use("/api/reportes", reportesRoute);
router.use("/api/archivos-extensiones", archivosExtensionesRoute);

router.use("/api/administracion/usuarios", [tokenAuth.verifyToken], usuariosRoute);
router.use("/api/administracion/roles", [tokenAuth.verifyToken], rolesRoute);
router.use("/api/administracion/sucursales", [tokenAuth.verifyToken], sucursalesRoute);
router.use("/api/administracion/status_empleado", [tokenAuth.verifyToken], status_empleadoRoute);
router.use("/api/administracion/clientes", [tokenAuth.verifyToken], clientesRoute);

router.use("/api/tipo_productos", [tokenAuth.verifyToken], tipoProductosRoute);
router.use("/api/marcas", [tokenAuth.verifyToken], marcasRoute);
router.use("/api/familia_nivel_1", [tokenAuth.verifyToken], familiaNivel1Route);
router.use("/api/familia_nivel_2", [tokenAuth.verifyToken], familiaNivel2Route);
router.use("/api/familia_nivel_3", [tokenAuth.verifyToken], familiaNivel3Route);
router.use("/api/grupos", [tokenAuth.verifyToken], gruposRoute);
router.use("/api/productos_codigos_alternos", [tokenAuth.verifyToken], pcaRoute);
router.use("/api/productos_componentes", [tokenAuth.verifyToken], pcRoute);

module.exports = router;
